#include <iostream.h>
#include <string.h>
#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include "strings.h"
#include "quests.h"
#include "video.h"
#include "font.h"
#include "text.h"
#include "kb.h"

enum langs  {ENGLISH = 0, RUSSIAN};
unsigned language = ENGLISH;
unsigned main_score = 0;

void DrawBackground()
{
  int i = 0, j;

  for (; i < 80; i++)
    for (j = 0; j < 25; j++)
      out_char(i, j, random(2) + '0', 0x08);
}

void SinkImage()
{
  int i = 0, j, k;

  for (; i < 25; i++)
  {
    for (j = 24; j > i; j--)
      copy_line(j - 1, j);

    for (k = 0; k < 80; k++)
      out_char(k, j, random(2) + '0', 0x08);

    ClearBuf();
    vert_ret();
    vert_ret();
  }
}

void Intro()
{
  int i = 0, j, k;

  for (; i < 78; i++)
  {
    for (j = 0; j < 12; j++)
    {
      if (j % 2)
      {
        if (i >= 75)
          out_char(i - 75, j + 6, random(2) + '0', 0x08);
        out_string(i < 75 ? 0 : i - 74, j + 6, splash[j] + (74 - i) * (i < 75), 0x1B);
      }
      else
      {
        for (k = 0; k < (i < 75 ? i : 74); k++)
          out_char(80 - i + k, j + 6, splash[j][k], 0x1B);
        if (i > 74)
          out_char(80 - (i - 74), j + 6, random(2) + '0', 0x08);
      }
    }

    ClearBuf();
    vert_ret();
  }

  for (i = 0; i < strlen(presskey); i++)
  {
    if (presskey[i] != ' ')
      out_char(i * 2 + 26, 23, presskey[i], 0x0E);
    delay(100);
  }

  ClearBuf();
  getch();
  SinkImage();
}

void Init()
{
  randomize();
  set_mode(0x03);
  _setcursortype(_NOCURSOR);
  set_font((void far *)main_font);
  DrawBackground();
}

void SetLanguage()
{
  char c, attr1 = 0x70, attr2 = 0x1F;

  frame1(20, 10, 40, 4, 0x1B);
  out_string(32, 10, " Select language ", 0x1E);
  out_string(37, 11, "English", 0x1F);
  out_string(37, 12, "᪨", 0x1F);
  set_attr(21, 11, 38, 1, attr1);

  do
  {
    c = getch();
    if (c == 80 || c == 72)
    {
      attr1 ^= attr2;
      attr2 ^= attr1;
      attr1 ^= attr2;
      language ^= 1;
    }
    set_attr(21, 11, 38, 1, attr1);
    set_attr(21, 12, 38, 1, attr2);
  } while (c != 13);

  SinkImage();
}

void Done()
{
  _setcursortype(_NORMALCURSOR);
  set_mode(0x03);
}

int Help()
{
  int i = 0, beg_score = 0;
  char num[20], c;

  frame2(5, 2, 70, 21, 0x1F);

  for (; i < 6; i++)
    out_string(8, 3 + i, intro[language][i], 0x1A);

  out_string(8, 10, score_title[language], 0x1B);

  for (i = 0; i < 7; i++)
  {
    sprintf(num, "0x%03X %s 0x%03X", beg_score, and[language], score_table[i]);
    beg_score = score_table[i] + 1;
    out_string(10, 12 + i, num, 0x1F);
    out_string(32, 12 + i, "->", 0x1F);
    out_string(40, 12 + i, score[language][i], 0x1F);
  }

  out_string(8, 20, comments[language], 0x4E);

  out_string(40 - strlen(ask_quit[language]) / 2, 24, ask_quit[language], 0x2F);
  ClearBuf();
  c = getch();
  SinkImage();
  return ((c == 'n') || (c == 'N') || (c == 27)) ? 1 : 0;
}

void PressKey()
{
  for (int i = 0; i < strlen(presskey); i++)
  {
    if (presskey[i] != ' ')
    {
      out_char(0, 6 + i, presskey[i], 0x0E);
      out_char(79, 6 + i, presskey[i], 0x0E);
      delay(100);
    }
    ClearBuf();
  }

  getch();
}

void Question()
{
  frame1(38 - strlen(question[language]) / 2, 11,
         strlen(question[language]) + 4, 3, 0x1B);
  out_string(40 - strlen(question[language]) / 2, 12, question[language], 0x1A);

  PressKey();
  SinkImage();
}

void Questions()
{
  int i = 0, j, q = language + '4', t = language + '1', lines, index, y;
  char c, b;

  while (((i < 1006) && language) || ((i < 1005) && !language))
  {
    DrawBackground();
    lines = b = 0;
    index = i;

    while ((questions[i][0] != q) && (questions[i][0] != '6'))
    {
      if ((questions[i][0] == t) || (questions[i][0] == '3'))
      {
        lines += count_lines(questions[i] + 2, 40);
        b++;
      }
      i++;
    }

    if (b) lines++;
    lines += count_lines(questions[i] + 2, 40);

    y = (25 - lines) / 2;
    frame2(18, y - 1, 44, lines + 2, 0x1B);

    for (j = index; j < i; j++)
    {
      if ((questions[j][0] == t) || (questions[j][0] == '3'))
        print_centered_string(y, 40, questions[j] + 2, 0x1B);
    }

    print_centered_string(y + lines - count_lines(questions[i] + 2, 40),
                          40, questions[i] + 2, 0x1B);
    i++;

    c = getch();
    if (c == 27) return;
    if (c == 'y' || c == 'Y' || c == 13)
      main_score++;
  }
}

void End()
{
  int i;

  frame2(5, 5, 70, 15, 0x1F);

  for(i = 0; i < 2; i++)
    out_string(7, 6 + i, prolog1[language][i], 0x1A);

  for(i = 0; i < 5; i++)
    out_string(16, 9 + i, prolog2[i], 0x1B);

  out_string(7, 15, prolog3[language], 0x1A);

  for(i = 0; i < 2; i++)
    out_string(16, 17 + i, prolog4[i], 0x1B);

  PressKey();
  SinkImage();
}

void main()
{
  int i, last = 0;

  Init();
  Intro();
  SetLanguage();
  if (!Help())
  {
    char buf[50];
    Question();
    Questions();
    SinkImage();
    frame2(20, 12, 40, 4, 0x1F);
    sprintf(buf, "%s:  %d", results[language], main_score);
    out_string(40 - strlen(buf) / 2, 13, buf, 0x1E);
    for (i = 0; i < 7; i++)
    {
      if ((main_score >= last) && (main_score <= score_table[i]))
        break;
      last = score_table[i] + 1;
    }
    sprintf(buf, "%s:  %s", you[language], score[language][i]);
    out_string(40 - strlen(buf) / 2, 14, buf, 0x1E);
    PressKey();
    SinkImage();
  }
  End();
  Done();
  cout << "Shell (c) MATI Inc. 1999\n";
}
