#ifndef _VIDEO_H_
#define _VIDEO_H_

void out_char(int x, int y, char c, char attr);
void out_string(int x, int y, char *s, char attr);
void out_hotstring(int x, int y, char *s, char attr1, char attr2);
void fill(int x, int y, int w, int h, char c, char attr);
void set_attr(int x, int y, int w, int h, char attr);
void set_mode(unsigned mode);
void vert_ret();
void copy_line(int src, int dest);
void frame1(int x, int y, int w, int h, unsigned char attr);
void frame2(int x, int y, int w, int h, unsigned char attr);

void out_char(int x, int y, char c, char attr)
{
  asm
  {
      push   es
      mov    ax,  0B800h
      mov    es,  ax
      mov    di,  y
      shl    di,  7
      mov    bx,  y
      shl    bx,  5
      add    di,  bx
      mov    bx,  x
      shl    bx,  1
      add    di,  bx
      mov    al,  c
      mov    ah,  attr
      stosw
      pop    es
  }
}

void out_string(int x, int y, char *s, char attr)
{
  int i = 0;
  while (*s) out_char(x + i++, y, *s++, attr);
}

void out_hotstring(int x, int y, char *s, char attr1, char attr2)
{
  int j = 0;
  char attr = attr1;

  while (*s)
  {
    if (*s == '~')
      if (attr == attr1)
        attr = attr2;
      else
        attr = attr1;
    else
      out_char(x + j++, y, *s, attr);
    s++;
  }
}

void fill(int x, int y, int w, int h, char c, char attr)
{
  asm
  {
      push   es
      mov    ax,  0B800h
      mov    es,  ax
      mov    di,  y
      shl    di,  7
      mov    bx,  y
      shl    bx,  5
      add    di,  bx
      mov    bx,  x
      shl    bx,  1
      add    di,  bx
      mov    al,  c
      mov    ah,  attr
      mov    cx,  h
@@1:  push   cx
      mov    cx,  w
      rep    stosw
      mov    bx,  w
      shl    bx,  1
      sub    di,  bx
      add    di,  160
      pop    cx
      loop   @@1
      pop    es
  }
}

void set_attr(int x, int y, int w, int h, char attr)
{
  asm
  {
      push   es
      mov    ax,  0B800h
      mov    es,  ax
      mov    di,  y
      shl    di,  7
      mov    bx,  y
      shl    bx,  5
      add    di,  bx
      mov    bx,  x
      shl    bx,  1
      add    di,  bx
      inc    di
      mov    al,  attr
      mov    cx,  h
@@1:  push   cx
      mov    cx,  w
@@2:  stosb
      inc    di
      loop   @@2
      pop    cx
      mov    bx,  w
      shl    bx,  1
      sub    di,  bx
      add    di,  160
      loop   @@1
      pop    es
  }
}

void set_mode(unsigned mode)
{
  asm
  {
      mov    ax, mode
      int    10h
  }
}

void vert_ret()
{
  asm
  {
    cli
    mov dx, 03DAh
@1: in al, dx
    test al, 8
    jz @1
@2: in al, dx
    test al, 8
    jnz @2
    sti
  }
}

void copy_line(int src, int dest)
{
  asm
  {
    push ds
    mov ax, 0B800h
    mov ds, ax
    mov es, ax
    mov si, src
    mov ax, si
    shl si, 7
    shl ax, 5
    add si, ax
    mov di, dest
    mov ax, di
    shl di, 7
    shl ax, 5
    add di, ax
    mov cx, 80
    rep movsw
    pop ds
  }
}

void frame1(int x, int y, int w, int h, unsigned char attr)
{
  fill(x + 1, y, w - 2, 1, '', attr);
  fill(x + 1, y + h - 1, w - 2, 1, '', attr);
  fill(x, y + 1, 1, h - 2, '', attr);
  fill(x + w - 1, y + 1, 1, h - 2, '', attr);
  out_char(x, y, '', attr);
  out_char(x + w - 1, y, '', attr);
  out_char(x, y + h - 1, '', attr);
  out_char(x + w - 1, y + h - 1, '', attr);
  fill(x + 1, y + 1, w - 2, h - 2, ' ', attr);
}

void frame2(int x, int y, int w, int h, unsigned char attr)
{
  fill(x + 1, y, w - 2, 1, '', attr);
  fill(x + 1, y + h - 1, w - 2, 1, '', attr);
  fill(x, y + 1, 1, h - 2, '', attr);
  fill(x + w - 1, y + 1, 1, h - 2, '', attr);
  out_char(x, y, '', attr);
  out_char(x + w - 1, y, '', attr);
  out_char(x, y + h - 1, '', attr);
  out_char(x + w - 1, y + h - 1, '', attr);
  fill(x + 1, y + 1, w - 2, h - 2, ' ', attr);
}


#endif
